MT_JINF         equ     $102
MT_RJOB         equ     $104
MT_FRJOB        equ     $105
MT_SUSJB        equ     $108
MT_RELJB        equ     $109
MT_PRIOR        equ     $10B
IO_SBYTE        equ     $305
SD_TAB          equ     $311
UT_MINT         equ     $ce
UT_MTEXT        equ     $d0
BP_INIT         equ     $110
CA_GTINT        equ     $112
CA_GTLIN        equ     $118
NO_ERROR        equ     0
TIMEOUT         equ     -1
ERR_NO          equ     -6
ERR_BP          equ     -15
COUNTP          equ     7
COUNTF          equ     2
BV_CHBAS        equ     $30
BV_CHP          equ     $34
BV_RIP          equ     $58

START           lea     TABLE,a1
                move.w  BP_INIT,a2
                jsr     (a2)
                moveq   #0,d0
                move.b  #$80,$8f(a6)
                rts
TABLE           dc.w    COUNTP
                dc.w    jobs-*
                dc.b    3,'job'
                dc.w    job_p-*
                dc.b    5,'job_p'
                dc.w    job_ra-*
                dc.b    7,'job_rac'
                dc.w    job_ri-*
                dc.b    7,'job_rin'
                dc.w    job_rel-*
                dc.b    7,'job_rel'
                dc.w    job_s-*
                dc.b    5,'job_s'
                dc.w    help-*
                dc.b    5,'JHelp'
                dc.w    0
                dc.w    countf
                dc.w    job_name-*
                dc.b    7,'job_nam'
                dc.w    job_pri-*
                dc.b    7,'job_pri'
                dc.w    0
text01          dc.w    tex2-tex1
tex1            dc.b    'Job  Tag  Owner  Priority  Name',10
tex2
WHAT_CHANNEL    moveq   #1,d6
                cmpa.l  a3,a5
                beq.s   DO_DEFAULT
                btst    #7,1(a6,a3.l)
                beq.s   DO_DEFAULT
                move.l  a5,-(sp)
                movea.l a3,a5
                addq.l  #8,a5
                move.l  a5,-(sp)
                move.w  CA_GTINT,a2
                jsr     (a2)
                movea.l (sp)+,a3
                movea.l (sp)+,a5
                bne.s   ERROR
                move.w  0(a6,a1.l),d6
DO_DEFAULT      mulu    #$28,d6
                add.l   BV_CHBAS(a6),d6
                cmp.l   BV_CHP(a6),d6
                bhi.s   NOT_OPEN
                movea.l 0(a6,d6.l),a0
                moveq   #no_error,d0
ERROR           rts
NOT_OPEN        moveq   #ERR_NO,d0
                rts
BAD_PARAMETER   moveq   #ERR_BP,d0
                rts
what_id         move.w  ca_gtlin,a2
                jsr     (a2)
                bne.s   err_ret
                moveq   #err_bp,d0
                cmp.w   d7,d3
                bne.s   err_ret
                move.w  6(a6,a1.l),d1
                swap    d1
                move.w  2(a6,a1.l),d1
                rts
err_ret         move.l  (sp)+,d1
                rts
ende            moveq   #no_error,d0
                rts
jobs            bsr     what_channel
                lea     text01,a1
                move.w  ut_mtext,a2
                jsr     (a2)
                movea.l a0,a2
                moveq   #0,d1
loop_03         bsr.s   job_1
                moveq   #0,d2
                moveq   #mt_jinf&$ff,d0
                trap    #mt_jinf/$100
                tst.l   d0
                bne     ende
                bsr.s   job_2
                tst.l   d1
                bne.s   loop_03
                bra     ende
job_1           movem.l d1/a2,-(sp)
                movea.l a2,a0
                move.w  ut_mint,a2
                jsr     (a2)
                moveq   #5,d1
                moveq   #timeout,d3
                moveq   #sd_tab&$ff,d0
                trap    #sd_tab/$100
                move.w  (sp),d1
                move.w  ut_mint,a2
                jsr     (a2)
                moveq   #10,d1
                moveq   #timeout,d3
                moveq   #sd_tab&$FF,d0
                trap    #sd_tab/$100
                movem.l (sp)+,d1/a2
                rts
job_2           movem.l d1-d3/a0/a2,-(sp)
                move.w  d2,d1
                movea.l a2,a0
                move.w  ut_mint,a2
                jsr     (a2)
                moveq   #16,d1
                moveq   #timeout,d3
                moveq   #sd_tab&$FF,d0
                trap    #sd_tab/$100
                moveq   #'S',d1
                move.w  8(a7),d2
                bmi.s   do_suspend
                moveq   #' ',d1
do_suspend      moveq   #timeout,d3
                moveq   #io_sbyte&$FF,d0
                trap    #io_sbyte/$100
                move.w  10(a7),d1
                andi.w  #255,d1
                move.w  ut_mint,a2
                jsr     (a2)
                moveq   #27,d1
                moveq   #timeout,d3
                moveq   #sd_tab&$FF,d0
                trap    #sd_tab/$100
                movea.l 12(a7),a2
                cmpi.w  #$4AFB,6(a2)
                bne.s   no_standard
                lea     8(a2),a1
                move.w  ut_mtext,a2
                jsr     (a2)
no_standard     moveq   #10,d1
                moveq   #timeout,d3
                moveq   #io_sbyte&$FF,d0
                trap    #io_sbyte/$100
                movem.l (sp)+,d1-d3/a0/a2
                rts
job_p           moveq   #3,d7
                bsr     what_id
                move.b  11(a6,a1.l),d2
                moveq   #mt_prior&$FF,d0
                trap    #mt_prior/$100
                rts
job_ra          moveq   #2,d7
                bsr     what_id
                moveq   #no_error,d3
                moveq   #mt_frjob&$FF,d0
                trap    #mt_frjob/$100
                rts
job_ri          moveq   #2,d7
                bsr     what_id
                moveq   #no_error,d3
                moveq   #mt_rjob&$FF,d0
                trap    #mt_rjob/$100
                rts
job_rel         moveq   #2,d7
                bsr     what_id
                moveq   #mt_reljb&$FF,d0
                trap    #mt_reljb/$100
                rts
job_s           moveq   #3,d7
                bsr     what_id
                move.w  10(a6,a1.l),d3
                moveq   #mt_susjb&$FF,d0
                trap    #mt_susjb/$100
                rts
job_name        moveq   #2,d7
                bsr     what_id
                moveq   #0,d2
                moveq   #mt_jinf&$FF,d0
                trap    #mt_jinf/$100
                tst.l   d0
                bne     ende
                cmpi.w  #$4afb,6(a0)
                bne     no_stand
                moveq   #0,d1
                move.w  8(a0),d1
                btst    #0,d1
                beq.s   job_name_1
                addq.l  #1,d1
                movea.l bv_rip(a6),a1
                suba.l  d1,a1
                subq.l  #2,a1
                move.l  a1,bv_rip(a6)
                move.w  d1,0(a6,a1.l)
                lea     2(a6,a1.l),a4
                move.b  #32,-1(a4,d1.l)
                bra.s   job_name_2
job_name_1      movea.l bv_rip(a6),a1
                suba.l  d1,a1
                subq.l  #2,a1
                move.l  a1,bv_rip(a6)
                move.w  d1,0(a6,a1.l)
                lea     2(a6,a1.l),a4
job_name_2      subq.l  #1,d1
                lea     10(a0),a3
job_name_3      move.b  (a3)+,(a4)+
                dbf     d1,job_name_3
                moveq   #1,d4
                moveq   #no_error,d0
                rts
no_stand        movea.l bv_rip(a6),a1
                suba.l  #4,a1
                move.l  a1,bv_rip(a6)
                move.w  #2,0(a6,a1.l)
                move.b  #' ',2(a6,a1.l)
                move.b  #' ',3(a6,a1.l)
                moveq   #1,d4
                moveq   #no_error,d0
                rts
job_pri         moveq   #2,d7
                bsr     what_id
                moveq   #0,d2
                moveq   #mt_jinf&$FF,d0
                trap    #mt_jinf/$100
                tst.l   d0
                bne     ende
                moveq   #0,d1
                move.w  d3,d1
                andi.w  #255,d1
                movea.l bv_rip(a6),a1
                subq.l  #2,a1
                move.l  a1,bv_rip(a6)
                move.w  d1,0(a6,a1.l)
                moveq   #3,d4
                rts
help            move.w  $c8,a2
                lea     win_head,a1
                jsr     (a2)
                move.w  $d0,a2
                lea     text_head,a1
                jsr     (a2)
                moveq   #2,d0
                trap    #2
                move.w  $c8,a2
                lea     window,a1
                jsr     (a2)
                move.w  $d0,a2
                lea     text,a1
                jsr     (a2)
                moveq   #2,d0
                trap    #2
                clr.l   d0
                move.b  #$80,$8f(a6)
                rts
window          dc.b    7,1,2,7
                dc.w    448,102,32,16
win_head        dc.b    2,1,7,0
                dc.w    448,12,32,2
text            dc.w    TE2-TE1
TE1       dc.b    'JOB     #c     - List All Jobs in Channel #c',10
          dc.b    'JOB_P j,t,p    - Set The Priority of Job(j) ,Tag (t)'
          dc.b    ' to p',10
          dc.b    'JOB_S j,t,s    - Suspend Job(j), Tag(t) for s Seconds'
          dc.b    10
          dc.b    'JOB_REL j,t    - Activate Job(j), Tag(t)',10
          dc.b    'JOB_RAC j,t    - Remove Job(j), Tag(t)',10
          dc.b    'JOB_RIN j,t    - same as JOB_RAC, except only for'
          dc.b    ' inactive jobs',10
          dc.b    '(JOB_NAM(j,t)) - Return Name of Job(j), Tag(t)',10
          dc.b    '(JOB_PRI(j,t)) - Return Priority of Job',10
          dc.b    'JHelp          - Show This list...',10
          dc.b    'No brackets : PROCedure, in Brackets: '
          dc.b    'FuNction ...'
TE2
text_head       dc.w    TH2-TH1
TH1             dc.b    'Help list from JTOOL-Mutitasking-Handling ...'
                dc.b    '..'
TH2
buffer          ds.b    312
  end
